Bug 132525 - df still does not produce correct output for 5 TB nfs mount (update 3 applied)
df still does not produce correct output for 5 TB nfs mount (update 3 applied)
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: coreutils (Show other bugs)
3.0
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Tim Waugh
:
Depends On: 132244
Blocks: 116428 123574 129681
  Show dependency treegraph
 
Reported: 2004-09-14 10:20 EDT by Jeremy Gwinnup
Modified: 2007-11-30 17:07 EST (History)
4 users (show)

See Also:
Fixed In Version: RHEL 3 update 4
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-01-05 10:27:00 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
output of: 'strace -estatfs64 df -h' (681 bytes, text/plain)
2004-09-14 10:26 EDT, Jeremy Gwinnup
no flags Details

  None (edit)
Description Jeremy Gwinnup 2004-09-14 10:20:50 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7)
Gecko/20040909 Firefox/0.9.3

Description of problem:
df still does not produce correct output for 5TB nfs mount:

(see bugs: 128418 126657 - both 'claim' to fix this issue)

example:

RHEL 3 AS machine: (Wrong output)
Linux mace-windu 2.4.21-20.ELsmp #1 SMP Wed Aug 18 20:46:40 EDT 2004
i686 i686 i386 GNU/Linux

mace-windu:jgwinnup> df -h
Filesystem            Size  Used Avail Use% Mounted on
/dev/sda5             2.0G  208M  1.7G  11% /
/dev/sda1              76M   57M   16M  78% /boot
none                  2.0G     0  2.0G   0% /dev/shm
/dev/sda7             1.4G   33M  1.3G   3% /tmp
/dev/sda3             4.0G  854M  3.0G  23% /usr
/dev/sda6             1.6G   67M  1.4G   5% /var
san1:/qfs             3.8T  2.7T  1.1T  72% /qfs
rebel:/samtest           1     1     1   0% /samtest

Debian sid box: (Correct output)
Linux yzerman 2.4.26-1-686 #3 Sun Apr 18 21:17:21 EST 2004 i686 GNU/Linux

yzerman:~# df -h
Filesystem            Size  Used Avail Use% Mounted on
/dev/hda5              36G  1.8G   32G   6% /
tmpfs                 252M     0  252M   0% /dev/shm
/dev/hda1              99M   18M   77M  19% /boot
/dev/hda3             487M  189M  273M  41% /var
san1:/qfs             3.8T  2.7T  1.1T  72% /qfs
rebel:/samtest        4.7T  1.1T  3.6T  24% /samtest


Solaris 8 box (Correct output):
SunOS galen 5.8 Generic_117350-05 sun4u sparc SUNW,Sun-Blade-1000

Filesystem            kbytes    used   avail capacity  Mounted on
/dev/dsk/c1t1d0s0    1021735   64022  896409     7%    /
/dev/dsk/c1t1d0s6    2058319  892682 1103888    45%    /usr
/proc                      0       0       0     0%    /proc
fd                         0       0       0     0%    /dev/fd
mnttab                     0       0       0     0%    /etc/mnttab
/dev/dsk/c1t1d0s5    8263373  393028 7787712     5%    /var
swap                 20013656       8 20013648     1%    /var/run
/dev/dsk/c1t1d0s7    8263373  743424 7437316    10%    /opt
/dev/dsk/c1t1d0s4    34431237     762 34086163     1%    /tmp
san1:/qfs            3992794624 2874365440 1118429184    72%    /qfs

rebel:/samtest       4990993280 1158531600 3832461680    24%    /samtest


Version-Release number of selected component (if applicable):
coreutils-4.5.3-26

How reproducible:
Always

Steps to Reproduce:
1. df -h
2. 
3.
    

Actual Results:  mace-windu:jgwinnup> df -h
Filesystem            Size  Used Avail Use% Mounted on
/dev/sda5             2.0G  208M  1.7G  11% /
/dev/sda1              76M   57M   16M  78% /boot
none                  2.0G     0  2.0G   0% /dev/shm
/dev/sda7             1.4G   33M  1.3G   3% /tmp
/dev/sda3             4.0G  854M  3.0G  23% /usr
/dev/sda6             1.6G   67M  1.4G   5% /var
san1:/qfs             3.8T  2.7T  1.1T  72% /qfs
rebel:/samtest           1     1     1   0% /samtest


Expected Results:  yzerman:~# df -h
Filesystem            Size  Used Avail Use% Mounted on
/dev/hda5              36G  1.8G   32G   6% /
tmpfs                 252M     0  252M   0% /dev/shm
/dev/hda1              99M   18M   77M  19% /boot
/dev/hda3             487M  189M  273M  41% /var
san1:/qfs             3.8T  2.7T  1.1T  72% /qfs
rebel:/samtest        4.7T  1.1T  3.6T  24% /samtest
yzerman:~# df -h
Filesystem            Size  Used Avail Use% Mounted on
/dev/hda5              36G  1.8G   32G   6% /
tmpfs                 252M     0  252M   0% /dev/shm
/dev/hda1              99M   18M   77M  19% /boot
/dev/hda3             487M  189M  273M  41% /var
san1:/qfs             3.8T  2.7T  1.1T  72% /qfs
rebel:/samtest        4.7T  1.1T  3.6T  24% /samtest

Additional info:

make sure "_FILE_OFFSET_BITS 64" is defined while compiling

Also, check against kernel, kernel-smp packages - could be a culprit
Comment 1 Tim Waugh 2004-09-14 10:22:46 EDT
Please attach the output of 'strace -estatfs64 df -h'.
Comment 2 Jeremy Gwinnup 2004-09-14 10:26:36 EDT
Created attachment 103827 [details]
output of: 'strace -estatfs64 df -h'
Comment 3 Tim Waugh 2004-09-14 10:28:01 EDT
It's the stderr I'm interested in.

strace -estatfs64 df -h 2>log

then attach 'log'.  Thanks.
Comment 4 Jeremy Gwinnup 2004-09-14 10:31:13 EDT
stderr does not produce any output with that call - When I substitute
the regular statfs call in the strace call above, I get a ton of info.
Comment 5 Jeremy Gwinnup 2004-09-14 11:00:16 EDT
Bug 132244 (from kernel package) seems related...

FYI
Comment 6 Tim Waugh 2004-09-14 11:04:03 EDT
Yes, indeed.  I'd forgotten about statfs64 not being available in the
kernel..
Comment 7 Rik van Riel 2004-09-21 23:12:08 EDT
I've got the kernel side of statfs64 ready (for x86 and NFS).
Comment 8 Rik van Riel 2004-09-22 17:41:44 EDT
A patch adding the statfs64 syscall to RHEL3 x86 has been submitted today.
Comment 9 Dan Bongert 2004-10-01 17:32:08 EDT
I am seeing the exact same output with much smaller NFS mounts.
(1GB-100GB) Also, some NFS partitions work and some don't, no matter
the size.

On a client machine: 
[root@merlin root]# df -h /usr/ftp /home/d
Filesystem            Size  Used Avail Use% Mounted on
griffon:/usr/ftp         1     1     1   0% /usr/ftp
griffon:/home/d       124G   96G   22G  82% /home/d

On the file server:
[root@griffon root]# df -h /usr/ftp /home/d
Filesystem            Size  Used Avail Use% Mounted on
/dev/raid1/ftp1       8.0G  1.7G  6.4G  21% /usr/ftp
/dev/raid2/home       124G   96G   22G  82% /home

My clients are all RHEL 3 WS and AS, fully updated via up2date.
Comment 10 Tim Waugh 2004-10-04 11:57:53 EDT
As far as I can tell from inspecting the code in fsusage.c/fsusage.h,
df is ready for statfs64 as soon as glibc will use it.

Can anyone confirm/deny that glibc is the only missing piece in this now?
Comment 12 Jeremy Gwinnup 2004-10-11 10:17:24 EDT
this sounds correct - I've built gnu df via coreutils on solaris, I
just had to make sure that --enable-largefile was turned on.
Comment 13 Tim Waugh 2004-10-11 11:16:40 EDT
Setting to MODIFIED for testing against the new kernel.
Comment 14 Jeremy Gwinnup 2005-01-05 10:27:00 EST
Update 4 with kernel 2.4.21-27.0.1 fixes this issue for me. df now
produces correct output on our large NFS mounts. Thanks for the help
in debugging this issue.

uname -r :
2.4.21-27.0.1.ELsmp

df -h:
san1:/qfs             4.8T  4.2T  662G  87% /qfs
san1:/qfs_old         3.8T  1.4T  2.4T  36% /qfs_old
san1:/DM              680G  302G  379G  45% /DM
san2:/scratch/user    1.6T  1.4T  237G  86% /scratch


Note You need to log in before you can comment on or make changes to this bug.